image: maven:3.8.5-openjdk-17
variables:
  CONTAINER_IMAGE: spring-petclinic
  DOCKER_REGISTRY: us-docker.pkg.dev/dotted-byway-411905/sample
  TF_DIR: ${CI_PROJECT_DIR}/terraform
  APP_DIR: ${CI_PROJECT_DIR}/terraform/k8s-workload
  PROJECT_ID: dotted-byway-411905


stages:
  - build
  - infra
  - deploy

create_artifact:
  stage: build
  script:
    - "mvn clean install -Dmaven.test.skip=true"
  artifacts:
    expire_in: 2 week
    when: on_success
    paths:
      - target/*.jar

create_docker_image:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375/
    DOCKER_DRIVER: overlay2
  before_script:
    - cat $GCLOUD_SERVICE_KEY | docker login -u _json_key --password-stdin https://us-docker.pkg.dev/dotted-byway-411905
    - docker info
  script:
    - docker build --tag $DOCKER_REGISTRY/$CONTAINER_IMAGE:latest .
    - docker push $DOCKER_REGISTRY/$CONTAINER_IMAGE:latest
  when: always
  needs:
    - create_artifact

infrastructure: 
  stage: infra
  image:
    name: hashicorp/terraform:light
    entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  before_script:
  - rm -rf .terraform
  - cd ${TF_DIR}
  - cp $GCLOUD_SERVICE_KEY /tmp/credentials.json
  - export GOOGLE_APPLICATION_CREDENTIALS=/tmp/credentials.json
  - terraform --version
  - terraform init
  script:
  - terraform validate
  - terraform plan
  - terraform apply --auto-approve
  needs:
    - create_docker_image

create_deployment: 
  stage: deploy
  image:
    name: google/cloud-sdk:alpine
  before_script:
    - cp $GCLOUD_SERVICE_KEY /tmp/credentials.json
    - cd ${CI_PROJECT_DIR}
  script:
   - cp $GCLOUD_SERVICE_KEY /tmp/credentials.json
   - gcloud config set project $PROJECT_ID
   - gcloud auth activate-service-account --key-file /tmp/credentials.json
   - gcloud container clusters get-credentials primary --location us-central1-a
   - gcloud components install kubectl
   - kubectl apply -f all-in-one.yaml
  needs:
    - infrastructure
